'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Matcher2 = require('../Matcher');

var _Matcher3 = _interopRequireDefault(_Matcher2);

var _Url = require('../components/Url');

var _Url2 = _interopRequireDefault(_Url);

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @copyright   2016, Miles Johnson
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @license     https://opensource.org/licenses/MIT
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

/*:: import type { MatchResponse, UrlProps } from '../types';*/

var UrlMatcher = function (_Matcher) {
  _inherits(UrlMatcher, _Matcher);

  function UrlMatcher() {
    _classCallCheck(this, UrlMatcher);

    return _possibleConstructorReturn(this, (UrlMatcher.__proto__ || Object.getPrototypeOf(UrlMatcher)).apply(this, arguments));
  }

  _createClass(UrlMatcher, [{
    key: 'factory',

    /**
     * {@inheritDoc}
     */
    value: function factory(match /*: string*/) {
      var props /*: Object*/ = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      return _react2.default.createElement(
        _Url2.default,
        props,
        match
      );
    }

    /**
     * @{inheritDoc}
     */

  }, {
    key: 'getTagName',
    value: function getTagName() {
      return 'a';
    }

    /**
     * {@inheritDoc}
     */

  }, {
    key: 'match',
    value: function match(string /*: string*/) {
      return this.doMatch(string, _constants.URL_PATTERN, this.handleMatches);
    }

    /**
     * Package the mached response.
     *
     * @param {String[]} matches
     * @returns {Object}
     */

  }, {
    key: 'handleMatches',
    value: function handleMatches(matches /*: string[]*/) {
      return {
        urlParts: {
          scheme: matches[1] ? matches[1].replace('://', '') : 'http',
          auth: matches[2] ? matches[2].substr(0, matches[2].length - 1) : '',
          host: matches[3],
          port: matches[4] ? matches[4].substr(1) : '',
          path: matches[5] || '',
          query: matches[6] || '',
          fragment: matches[7] || ''
        }
      };
    }
  }]);

  return UrlMatcher;
}(_Matcher3.default);

exports.default = UrlMatcher;